


; **********************************************************
;  Monitor
; **********************************************************



; Procedur: Monitor_UP
;
; Aufruf: WR_IMG_SEK
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;  

Monitor_UP:
		;
		LD	A,(Conn_B)
		LD	(RAM_AKT_CON),A
		;
		; Laden MonitorFunktion
		LD	A,(MonFkt_B)


		; 01 = Abrage des Fehlercodes
		;
		CP	1
		JR	NZ,Monitor_2
		;
;		CALL	INT_RD_ERROR
		LD	A,H
		LD	(Ergebnis_B),A
		LD	A,L
		LD	(ErgPar1_B),A
		;
		JR	Monitor_X
		;
Monitor_2:
		; 02 = RAM in FLASH Brennen (RAMFLOPPY)
		;
		CP	2
		JR	NZ,Monitor_3
		;
;		CALL	INT_RD_SA_RFL
		;
		JR	Monitor_X
		;
Monitor_3:
		; 03 = SECTOR lesen in DMA
		;
		CP	3
		JR	NZ,Monitor_4
		;
;		CALL	RD_IMG_SEK
		;
		JR	Monitor_X
		;

Monitor_4:
		; 04 = SECTOR schreiben aus DMA
		;
		CP	4
		JR	NZ,Monitor_6
		;
;		CALL	WR_IMG_SEK
		;
		JR	Monitor_X
		;
Monitor_6:
		; 06 = Lese SECNT
		;
		CP	6
		JR	NZ,Monitor_7
		;
;		CALL	INT_RE_SECNT
		;
		LD	(Ergebnis_B),A
		;
		JR	Monitor_X
		;

Monitor_7:

		; 06 = 07 = Schreibe SECNT
		;
		CP	7
		JR	NZ,Monitor_8
		;
		LD	A,(Ergebnis_B)
		LD	B,A
		;
;		CALL	INT_SE_SECNT
		;
		JR	Monitor_X
		;

Monitor_8:

Monitor_X:
		;
		RET








; Funktion: WordToCONOUT
;
; Aufruf: WordToCONOUT
; Uebergabeparameter: Register HL - Wordwert
; Rueckgabeparameter: keine
; 
WordToCONOUT:
		CALL	WordToHex		
		;
		PUSH	DE
		PUSH	BC
		;
		LD	C,B
		CALL	CONOUT
		;
		POP	BC
		;
		CALL	CONOUT
		;
		POP	DE
		PUSH	DE
		;
		LD	C,D
		CALL	CONOUT
		;
		POP	DE
		;
		LD	C,E
		CALL	CONOUT
		;
		LD	C,'H'
		CALL	CONOUT
		;
		RET





; Funktion: ByteToCONOUT
;
; Aufruf: ByteToCONOUT
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: keine
; 
ByteToCONOUT:
		CALL	ByteToHex
		PUSH	BC
		;
		LD	C,B
		CALL	CONOUT
		;
		POP	BC
		CALL	CONOUT
		;
		LD	C,'H'
		CALL	CONOUT
		;
		RET
		



; Funktion: WordToHex
;
; Aufruf: WordToHex
; Uebergabeparameter: Register HL = Wordwert
; Rueckgabeparameter: Register BC und DE - ASCII-Zeichen des Wordwertes
; 
WordToHex:
		LD	A,H
		PUSH	HL
		;
		CALL	ByteToHex
		;
		POP	HL
		PUSH	BC
		;
		LD	A,L
		;
		CALL	ByteToHex
		;
		LD	D,B
		LD	E,C
		POP	BC
		;
		RET







; Funktion: ByteToHex
;
; Aufruf: ByteToHex
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: Register BC - B = HWT, C = LWT
; 
ByteToHex:
		PUSH	AF
		AND	00FH
		;
		CALL	ByteToHex_A
		LD	C,A
		;
		POP	AF
		SRL	A
		SRL	A
		SRL	A
		SRL	A
		;
		CALL	ByteToHex_A
		LD	B,A
		;
		RET


ByteToHex_A:	ADD	A,'0'		; Zahl '0'
		CP	'9'+1		; '9'+1 -> 0..9 = Cyrry , A..F = not Curry
		RET	C
		;
		ADD	A,07		; 65D ('A') - 48D ('0') = 17D -> Differenz zw. '0' und 'A'
		;
		RET








; Funktion: 1 Sektor ab Adresse HL anzeigen (an CONOUT) 
;
; Aufruf: SEKToCONOUT
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Bytewerte
; 
SEKToCONOUT:
		LD	A,8
		;
SEKToCONOUT_1:
		PUSH	AF
		CALL	By16ToCONOUT
		;
		POP	AF
		;
		DEC	A
		JR	NZ,SEKToCONOUT_1
		;
		RET




; Funktion: 16 Byts ab Adresse HL anzeigen (an CONOUT) 
;
; Aufruf: By16ToCONOUT
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Bytewerte
; 
By16ToCONOUT:
		PUSH	HL
		;
		CALL	WordToCONOUT
		;
		LD	C,','
		CALL	CONOUT
		;
		POP	HL
		LD	A,16
		;
By16ToCONOUT_1:
		PUSH	AF
		;
		LD	A,(HL)
		INC	HL
		PUSH	HL
		;
		CALL	ByteToCONOUT
		;
		LD	C,','
		CALL	CONOUT
		;
		POP	HL	
		POP	AF
		;
		DEC	A
		JR	NZ,By16ToCONOUT_1
		;
		PUSH	HL
		;
		LD	HL,ZK_CRLF	; Abschluss der Eingabezeile
		CALL	AUS_ZK
		;
		POP	HL
		;
		RET












